

<h1 align="center">@tsei/core</h1>
<p align="center">🌌Fantastic <b>UI</b> in next tsei.jp</p>
<p align="center">
    <img alt="build passing" src="https://img.shields.io/badge/build-👌-green.svg"/>
    <img alt="types passing" src="https://img.shields.io/badge/types-👌-yellow.svg"/>
    <img alt="demos passing" src="https://img.shields.io/badge/demos-👌-red.svg"/>
    <br>
    <img alt="license MIT" src="https://img.shields.io/badge/license-MIT-green.svg"/>
    <img alt="npm package" src="https://badge.fury.io/js/%40tsei%2Fcore.svg"/>
</p>

<hr>

# Table of Contents
- [Install via npm](#install-via-npm)  
- [Demo and Docs](#demo-and-docs)  
- [Available hook](#available-hook)  
- [Simple example](#simple-example)  

# Install via npm
- `npm install @tsei/core`

# Demo and Docs
- [home](https://tsei.jp/home/)
- [core](https://tsei.jp/hook/)
- [mdmd](https://tsei.jp/mdmd/)
- [note](https://tsei.jp/note/)
- [grid](https://tsei.jp/hook/use-grid/)

# Get Started
- `git clone https://github.com/tseijp/core`
- `cd core`, `npm i` and `npm start`
- open browser and visit [http://localhost:3000](http://localhost:3000)
- Now you can go to our [demo](https://tsei.jp/hook/), and try its usage.

# Available hook
hooks | what?  
:-----|:-----  
[useGrid](https://github.com/tseijp/use-grid) | build responsive layouts of all shapes and sizes
usePage | manage page transitions and restful api urls

<details>
<summary>

# Recipes

</summary>
<table>
<tr align="center"><td><br/>

[![ Components ](
    https://img.shields.io/badge/Components-black.svg)](
    https://github.com/tseijp/core/tree/master/src/components/)

</td><td><br/>

[![ Demo ](
    https://img.shields.io/badge/Demo-black.svg)](
    https://github.com/tseijp/core/tree/master/page/demos/components)

</td></tr><tr><td>
<h6>Card</h6>
</td><td>

```tsx
<Card/>
```

</td></tr><tr><td>
<h6>Code</h6>
</td><td>

```tsx
<Code/>
```

</td></tr><tr><td>
<h6>Grow</h6>
</td><td>

```tsx
<Grow/>
```

</td></tr><tr><td>
<h6>Head</h6>
</td><td>

```tsx
<Head/>
```

</td></tr><tr><td>
<h6>Foot</h6>
</td><td>

```tsx
<Foot/>
```

</td></tr><tr><td>

<h6>Icon</h6>
</td><td>

```tsx
<Icon/>
```

</td></tr></table>
</details>
