import React$1, { useMemo, Children, useState, useEffect, useCallback, useRef } from 'react';
import { useGesture, useMove, useDrag } from 'react-use-gesture';
import { useSpring, animated, config, useSprings } from 'react-spring';
import styled from 'styled-components';
import { createPortal } from 'react-dom';

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var _templateObject$b;
function useCard(props, ref) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      _props$rate = props.rate,
      rate = _props$rate === void 0 ? 1 : _props$rate,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      other = _objectWithoutPropertiesLoose(props, ["size", "rate", "style"]);

  var _useSpring = useSpring(function () {
    return {
      xyz: [0, 0, 0]
    };
  }),
      xyz = _useSpring[0].xyz,
      set = _useSpring[1];

  var calc = function calc(x, y) {
    if (x === void 0) {
      x = 0;
    }

    if (y === void 0) {
      y = 0;
    }

    return typeof window !== 'undefined' ? [(x - window.innerWidth / 2) / size / 250, // -1 ~ 1
    (y - window.innerHeight / 2) / size / 250, // -1 ~ 1
    rate] : [0, 0, 0];
  };

  var bind = useGesture({
    onDrag: function onDrag(_ref) {
      var event = _ref.event;
      return event == null ? void 0 : event.stopPropagation();
    },
    onMove: function onMove(_ref2) {
      var _ref2$xy = _ref2.xy,
          x = _ref2$xy[0],
          y = _ref2$xy[1];
      return set({
        xyz: calc(x, y)
      });
    },
    onHover: function onHover(_ref3) {
      var hovering = _ref3.hovering;
      return !hovering && set({
        xyz: [0, 0, 0]
      });
    }
  });
  var card = useMemo(function () {
    var boxShadow = xyz.to(function (x, y, z) {
      return [1.5 - y * 2 + "rem", // offset-y     : -0.5 ~ 1.5 ~ 3.5
      0.5 - x * 2 + "rem", // offset-x     : -1.5 ~ 0.5 ~ 2.5
      1.5 + z + "rem", // blur-radius  : 1.5 =hover=> 2.5
      z - 0.5 + "rem", // spread-radius:-0.5 =hover=> 0.5
      "hsl(200 50% 20% / " + (15 + z * 5) + "%)"].join(' ');
    });
    var transform = xyz.to(function (x, y, z) {
      return ["perspective(" + size * 50 + "px)", "rotateX(" + -y / 10 + "deg)", // -0.1 ~ 0.1
      "rotateY(" + x / 10 + "deg)", // -0.1 ~ 0.1
      "scale(" + (1 + z / 10) + ")"].join(' ');
    });
    var zIndex = xyz.to(function (x, y, z) {
      return x * y * z > 0 ? 1 : 0;
    });
    return {
      boxShadow: boxShadow,
      transform: transform,
      zIndex: zIndex
    };
  }, [xyz, size]);
  return _extends({}, other, bind(), {
    ref: ref,
    style: _extends({}, card, style)
  });
}
var Card = styled( /*#__PURE__*/React$1.forwardRef(function (p, r) {
  return /*#__PURE__*/React$1.createElement(animated.div, useCard(p, r));
})).attrs(function (_) {
  var _ref4, _$min, _$max;

  var minHeight = (_ref4 = (_$min = _.min) != null ? _$min : _.size * 500) != null ? _ref4 : null;
  var maxHeight = (_$max = _.max) != null ? _$max : null;
  return {
    minHeight: minHeight,
    maxHeight: maxHeight
  };
})(_templateObject$b || (_templateObject$b = _taggedTemplateLiteralLoose(["\n    margin: ", "px auto ", "px auto;\n    padding: 0px;\n    position: relative;\n    width: min(80%, ", "px);\n    border-radius: ", "px;\n    overflow: hidden;\n    ", "\n    ", "\n    background: ", ";\n    color: ", "}\n"])), function (_) {
  return _.space;
}, function (_) {
  return _.space;
}, function (_) {
  return _.size * 500;
}, function (_) {
  return _.size * 25;
}, function (_) {
  return _.minHeight && "min-height: " + _.minHeight + "px;";
}, function (_) {
  return _.minHeight && "min-height: " + _.minHeight + "px;";
}, function (_) {
  return _.dark ? "#212121" : "#fff";
}, function (_) {
  return _.color || _.dark ? "#818181" : "#000";
});

var _templateObject$a, _templateObject2$6;
var Wrap$3 = styled.div(_templateObject$a || (_templateObject$a = _taggedTemplateLiteralLoose(["\n    position: relative;\n    left: 0;\n    bottom: 0;\n    height: auto;\n    background: #212121;\n    min-width: 100%;\n    borderRadius: ", ";\n    padding     : ", "\n"])), function (_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? 1 : _ref$size;
  return size * 25 + "px " + size * 25 + "px 0px 0px";
}, function (_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 1 : _ref2$size;
  return "0px " + size * 50 + "px " + size * 25 + "px " + size * 50 + "px";
});
var Item$2 = styled.div(_templateObject2$6 || (_templateObject2$6 = _taggedTemplateLiteralLoose(["\n    position: relative;\n    text-align: center;\n    fontSize: ", "\n"])), function (_ref3) {
  var size = _ref3.size;
  return ~~(size * 50) + "px";
});
var Foot = /*#__PURE__*/React$1.forwardRef(function (_ref4, ref) {
  var children = _ref4.children;
      _ref4.size;
      var _ref4$style = _ref4.style,
      style = _ref4$style === void 0 ? {} : _ref4$style,
      props = _objectWithoutPropertiesLoose(_ref4, ["children", "size", "style"]);

  return /*#__PURE__*/React$1.createElement(Wrap$3, _extends({}, props, {
    ref: ref,
    style: style
  }), Children.map(children, function (child) {
    return /*#__PURE__*/React$1.createElement(Item$2, null, child);
  }));
});

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

var _templateObject$9;
function useGrow(props, ref) {
  var _props$active = props.active,
      active = _props$active === void 0 ? true : _props$active,
      _props$dark = props.dark,
      dark = _props$dark === void 0 ? 1 : _props$dark,
      _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      _props$width = props.width,
      width = _props$width === void 0 ? 250 : _props$width,
      _props$timeout = props.timeout,
      timeout = _props$timeout === void 0 ? 250 : _props$timeout;

  var _React$useState = React$1.useState(false),
      close = _React$useState[0],
      set = _React$useState[1];

  var _useSpring = useSpring({
    reset: true,
    from: {
      opacity: 1,
      r: 0
    },
    to: active && !close ? /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(next) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return next({
                  opacity: 0,
                  r: width * size
                });

              case 2:
                set(true);
                setTimeout(function () {
                  return void set(false);
                }, timeout);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }() : {
      opacity: 1,
      r: 0
    }
  }),
      opacity = _useSpring.opacity,
      r = _useSpring.r;

  return {
    style: {
      opacity: opacity,
      width: r,
      height: r
    },
    dark: dark,
    ref: ref,
    size: size
  };
}
var Grow = styled( /*#__PURE__*/React$1.forwardRef(function (p, r) {
  return /*#__PURE__*/React$1.createElement(animated.div, useGrow(p, r));
})).attrs(function (_) {
  return {
    color: _.dark ? "#818181" : "#212121"
  };
})(_templateObject$9 || (_templateObject$9 = _taggedTemplateLiteralLoose(["\n    top: 50%;\n    left: 50%;\n    margin: 0px;\n    transform: translateX(-50%) translateY(-50%);\n    border: 1rem solid ", ";\n    background: ", ";\n    border-radius: 100%;\n    position: absolute;\n"])), function (props) {
  return props.color;
}, function (props) {
  return props.color;
});

var _templateObject$8;
var Head = styled.div.attrs(function (_) {
  var _$size, _$dark, _$color;

  return {
    size: (_$size = _.size) != null ? _$size : 1,
    dark: (_$dark = _.dark) != null ? _$dark : false,
    color: ((_$color = _.color) != null ? _$color : _.dark) ? "#818181" : "#000"
  };
})(_templateObject$8 || (_templateObject$8 = _taggedTemplateLiteralLoose(["\n    font-size: ", "px;\n    color: ", ";\n    width:", ";\n    height: auto;\n    margin: auto;\n"])), function (_ref) {
  var size = _ref.size;
  return size * 50;
}, function (props) {
  return props.color;
}, function (_ref2) {
  var size = _ref2.size;
  return "max(70vw, 100vw - " + size * 200 + "px)";
});

var _templateObject$7;
function useIcon(props, ref) {
  var _props$fa = props.fa,
      fa = _props$fa === void 0 ? "" : _props$fa,
      _props$fab = props.fab,
      fab = _props$fab === void 0 ? "" : _props$fab,
      _props$dark = props.dark,
      dark = _props$dark === void 0 ? false : _props$dark,
      _props$circ = props.circ,
      circ = _props$circ === void 0 ? true : _props$circ,
      _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      other = _objectWithoutPropertiesLoose(props, ["fa", "fab", "dark", "circ", "size"]);

  var _useSpring = useSpring(function () {
    return {
      xys: [0, 0, 0]
    };
  }),
      xys = _useSpring[0].xys,
      set = _useSpring[1];

  var bind = useMove(function (_ref) {
    var _ref$vxvy = _ref.vxvy,
        vx = _ref$vxvy[0],
        vy = _ref$vxvy[1],
        last = _ref.last;
    return set({
      xys: [vx, vy, last ? 0 : 1]
    });
  });
  var color = useMemo(function () {
    return props.color || circ ? dark ? "#818181" : "#fff" : "#212121";
  }, [props.color, circ, dark]);
  var className = useMemo(function () {
    return props.className + fa ? " fas fa-" + fa : fab ? " fab fa-" + fab : "";
  }, [props.className, fa, fab]);
  var style = useMemo(function () {
    return {
      filter: xys.to(function (x, y, s) {
        return ["drop-shadow(" + (0.1 + x) + "rem", // -x~0.5~x
        0.5 + y + "rem", // -y~1.5~y
        1 - s / 2 + "rem", // 1 =hover=> 0.5
        "rgba(0,0,0, " + (0.5 + s / 20) + "))" // 0.50 =hover=> 0.55
        ].join(' ');
      }),
      transform: xys.to(function (x, y, s) {
        return ["perspective(" + size * 50 + "px)", "rotateX(" + -y + "deg)", //-1 ~ 1
        "rotateY(" + x + "deg)", //-1 ~ 1
        "scale(" + (1 + s / 10) + ")" // 1 ~ 1.1
        ].join(' ');
      })
    };
  }, [xys, size]);
  return _extends({}, other, bind(), {
    style: style,
    className: className,
    color: color,
    size: size,
    ref: ref
  });
}
var Icon = styled( /*#__PURE__*/React$1.forwardRef(function (p, r) {
  return /*#__PURE__*/React$1.createElement(animated.div, useIcon(p, r));
}))(_templateObject$7 || (_templateObject$7 = _taggedTemplateLiteralLoose(["\n    top: 0px;\n    right: 0px;\n    padding: 0px;\n    text-align: center;\n    user-select: none;\n    color: ", ";\n    width: ", "px;\n    height: ", "px;\n    font-size: ", "px;\n    border-radius: ", "px;\n    background: ", ";\n"])), function (props) {
  return props.color;
}, function (_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 1 : _ref2$size;
  return size * 50;
}, function (_ref3) {
  var _ref3$size = _ref3.size,
      size = _ref3$size === void 0 ? 1 : _ref3$size;
  return size * 50;
}, function (_ref4) {
  var _ref4$size = _ref4.size,
      size = _ref4$size === void 0 ? 1 : _ref4$size;
  return size * 50;
}, function (_ref5) {
  var _ref5$size = _ref5.size,
      size = _ref5$size === void 0 ? 1 : _ref5$size;
  return size * 50;
}, function (props) {
  return props.circ ? "#212121" : "";
});

var _templateObject$6, _templateObject2$5, _templateObject3$2, _templateObject4$2, _templateObject5$2;
var treesPaths = {
  Minus: "M888 760v0v0v-753v0h-752v0v753v0h752zM888 832h-752q-30 0 -51 -21t-21 -51v-753q0 -29 21 -50.5t51 -21.5h753q29 0 50.5 21.5t21.5 50.5v753q0 30 -21.5 51t-51.5 21v0zM732 347h-442q-14 0 -25 10.5t-11 25.5v0q0 15 11 25.5t25 10.5h442q14 0 25 -10.5t11 -25.5v0 q0 -15 -11 -25.5t-25 -10.5z",
  Plus: "M888 760v0v0v-753v0h-752v0v753v0h752zM888 832h-752q-30 0 -51 -21t-21 -51v-753q0 -29 21 -50.5t51 -21.5h753q29 0 50.5 21.5t21.5 50.5v753q0 30 -21.5 51t-51.5 21v0zM732 420h-184v183q0 15 -10.5 25.5t-25.5 10.5v0q-14 0 -25 -10.5t-11 -25.5v-183h-184 q-15 0 -25.5 -11t-10.5 -25v0q0 -15 10.5 -25.5t25.5 -10.5h184v-183q0 -15 11 -25.5t25 -10.5v0q15 0 25.5 10.5t10.5 25.5v183h184q15 0 25.5 10.5t10.5 25.5v0q0 14 -10.5 25t-25.5 11z"
};
var treesConfig = {
  restSpeedThreshold: 1,
  restDisplacementThreshold: 0.01
};
function useTrees(props) {
  var _props$open = props.open,
      open = _props$open === void 0 ? true : _props$open,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      _props$immediate = props.immediate,
      immediate = _props$immediate === void 0 ? true : _props$immediate,
      springconfig = props.springconfig;

  var _useState = useState({
    open: open,
    visible: visible,
    immediate: immediate
  }),
      state = _useState[0],
      set = _useState[1];

  var bind = useGesture({
    onClick: function onClick() {
      return set && set(function (p) {
        return {
          open: !p.open,
          immediate: false
        };
      });
    }
  });
  var spring = useSpring({
    immediate: state.immediate,
    config: _extends({}, config.default, springconfig || treesConfig),
    from: {
      height: 0,
      opacity: 0,
      transform: 'translate3d(20px,0,0)'
    },
    to: {
      height: state.open ? 'auto' : 0,
      opacity: state.open ? 1 : 0,
      transform: state.open ? 'translate3d(0px,0,0)' : 'translate3d(20px,0,0)'
    }
  });
  var path = useMemo(function () {
    return props.children && treesPaths[state.open ? 'Minus' : 'Plus'];
  }, [props.children, state.open]);
  useEffect(function () {
    set(function (p) {
      return visible !== p.visible ? _extends({}, p, {
        visible: visible
      }) : p;
    });
  }, [visible]);
  return [spring, bind, path];
}
var TreesTop = styled(animated.div)(_templateObject$6 || (_templateObject$6 = _taggedTemplateLiteralLoose(["\n    padding: 4px 0px 0px 0px;\n    position: relative;\n    overflow: hidden;\n    vertical-align: middle;\n    white-space: nowrap;\n    text-overflow: ellipsis;\n    border-left: ", ";\n    padding: ", ";\n"])), function (props) {
  return "1px dashed #" + (props.dark ? 818181 : 212121);
}, function (props) {
  return "4px 0px 0px " + props.size * 25 + "px";
});
var TreesMain = styled(animated.div)(_templateObject2$5 || (_templateObject2$5 = _taggedTemplateLiteralLoose(["\n    font-size: ", "px;\n    will-change: transform, opacity, height;\n    margin-left: 6;\n"])), function (props) {
  return props.size * 50;
});
var TreesType = styled(animated.span)(_templateObject3$2 || (_templateObject3$2 = _taggedTemplateLiteralLoose(["\n    font-size: 0.6em;\n    font-family: monospace;\n    text-transform: uppercase;\n    white-space: nowrap;\n    vertical-align: middle;\n    margin-right: ", ";\n    color: ", ";\n"])), function (props) {
  return props.type ? 10 : 0;
}, function (props) {
  return props.color;
});
var TreesCont = styled(animated.div)(_templateObject4$2 || (_templateObject4$2 = _taggedTemplateLiteralLoose(["\n    display: inline-block;\n    vertical-align: middle;\n    font-size: ", "px;\n    color: ", ";\n"])), function (props) {
  return props.size * 50;
}, function (props) {
  return props.color;
});
var TreesIcon = styled.svg(_templateObject5$2 || (_templateObject5$2 = _taggedTemplateLiteralLoose(["\n    width: 1em;\n    height: 1em;\n    cursor: pointer;\n    margin-right: 10;\n    vertical-align: middle;\n    font-size: ", "px;\n    color: ", "\n"])), function (props) {
  return props.size * 50;
}, function (props) {
  return props.color;
});
function Trees(props) {
  var content = props.content,
      type = props.type,
      _props$depth = props.depth,
      depth = _props$depth === void 0 ? 0 : _props$depth,
      _props$root = props.root,
      root = _props$root === void 0 ? 1 : _props$root,
      _props$size = props.size,
      size = _props$size === void 0 ? 1.5 : _props$size,
      _props$dark = props.dark,
      dark = _props$dark === void 0 ? false : _props$dark,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      _props$viewBox = props.viewBox,
      viewBox = _props$viewBox === void 0 ? "64 -65 897 897" : _props$viewBox;

  var _useTrees = useTrees(props),
      spring = _useTrees[0],
      bind = _useTrees[1],
      path = _useTrees[2];

  var color = useMemo(function () {
    return dark ? "#818181" : "#212121";
  }, [dark]);
  var main = useMemo(function () {
    return Children.map(props.children, function (child) {
      var _props;

      var grand = Children.toArray(child == null ? void 0 : (_props = child.props) == null ? void 0 : _props.children) || [];
      return props.children && /*#__PURE__*/React$1.createElement(Trees, _extends({}, props, {
        depth: depth + 1,
        topStyle: {},
        open: depth < root,
        children: grand.length > 1 ? grand.slice(1) : null,
        immediate: false,
        content: grand.length > 1 ? grand[0] : child
      }));
    });
  }, [props, depth, root]);
  return /*#__PURE__*/React$1.createElement(TreesTop, {
    style: style,
    size: size
  }, path && !content ? null : /*#__PURE__*/React$1.createElement(TreesIcon, _extends({
    color: color,
    size: size,
    viewBox: viewBox
  }, bind()), /*#__PURE__*/React$1.createElement("g", null, /*#__PURE__*/React$1.createElement("path", {
    d: path
  }))), /*#__PURE__*/React$1.createElement(TreesType, {
    color: color,
    type: type
  }, type), /*#__PURE__*/React$1.createElement(TreesCont, {
    color: color,
    size: size
  }, content), /*#__PURE__*/React$1.createElement(TreesMain, {
    depth: depth,
    size: size,
    style: spring
  }, main));
}

var _templateObject$5, _templateObject2$4;
var Wrap$2 = styled(animated.div)(_templateObject$5 || (_templateObject$5 = _taggedTemplateLiteralLoose(["\n    left: 0;\n    bottom: 0;\n    width: 100%;\n    height: 100%;\n    position: absolute;\n"])));
var Item$1 = styled(animated.div)(_templateObject2$4 || (_templateObject2$4 = _taggedTemplateLiteralLoose(["\n    position: absolute;\n    will-change: transform;\n"])));
function Slide(props) {
  var _useSlide = useSlide(props),
      springs = _useSlide[0],
      bind = _useSlide[1];

  return /*#__PURE__*/React$1.createElement(Wrap$2, bind(), React$1.Children.map(props.children, function (children, i) {
    return /*#__PURE__*/React$1.createElement(Item$1, {
      key: i,
      style: springs[i],
      children: children
    });
  }));
}
function useSlide(_ref) {
  var children = _ref.children,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 600 : _ref$width,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? 4 : _ref$visible;
  var len = useMemo(function () {
    return children.length > visible ? children.length : visible;
  }, [children, visible]);
  var idx = useCallback(function (x) {
    return (x < 0 ? x + len : x) % len;
  }, [len]);
  var getPos = useCallback(function (i, firstVis, firstVisIdx) {
    return idx(i - firstVis + firstVisIdx);
  }, [idx]);

  var _useSprings = useSprings(len, function (i) {
    return {
      x: (i < len - 1 ? i : -1) * width
    };
  }),
      s = _useSprings[0],
      set = _useSprings[1];

  var prev = useRef([0, 1]);
  var drag = useRef(0);
  var wheel = useRef(0);
  var run = useCallback(function (xy, vxy) {
    var firstVis = idx(Math.floor(xy / width) % len);
    var firstVisIdx = vxy < 0 ? len - visible : 1;
    set(function (i) {
      var position = getPos(i, firstVis, firstVisIdx);
      var prevPosition = getPos(i, prev.current[0], prev.current[1]);
      var rank = firstVis - (xy < 0 ? len : 0) + position - firstVisIdx;
      var configPos = vxy > 0 ? position : len - position - 1;
      return {
        x: -xy % (width * len) + width * rank,
        immediate: vxy < 0 ? prevPosition > position : prevPosition < position,
        config: {
          tension: (1 + len - configPos) * 100,
          friction: 30 + configPos * 40
        }
      };
    });
    prev.current = [firstVis, firstVisIdx];
  }, [idx, getPos, width, visible, set, len]);
  var bind = useGesture({
    onDrag: function onDrag(_ref2) {
      var _ref2$offset = _ref2.offset,
          x = _ref2$offset[0],
          _ref2$vxvy = _ref2.vxvy,
          vx = _ref2$vxvy[0];
      return vx && (drag.current = -x, run(wheel.current - x, -vx));
    },
    onWheel: function onWheel(_ref3) {
      var _ref3$offset = _ref3.offset,
          y = _ref3$offset[1],
          _ref3$vxvy = _ref3.vxvy,
          vy = _ref3$vxvy[1];
      return vy && (wheel.current = y, run(drag.current + y, vy));
    }
  });
  return [s, bind];
}

function is(a, b) {
  for (var _len = arguments.length, other = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    other[_key - 2] = arguments[_key];
  }

  if (other.length > 0) return is(a, b) && is.apply(void 0, [b].concat(other));
  if (typeof a !== typeof b) return false;
  if (is.str(a) || is.num(a)) return a === b;
  if (is.obj(a) && is.obj(b) && is.len(0, a) && is.len(0, b)) return true;

  for (var i in a) {
    if (!(i in b)) return false;
  }

  for (var _i in b) {
    if (a[_i] !== b[_i]) return false;
  }

  return true;
}

is.arr = Array.isArray;

is.fls = function (a) {
  return is.und(a) || is.nul(a) || a === false || a === '';
};

is.nul = function (a) {
  return a === null;
};

is.und = function (a) {
  return a === void 0;
};

is.num = function (a) {
  return typeof a === 'number';
};

is.str = function (a) {
  return typeof a === 'string';
};

is.fun = function (a) {
  return typeof a === 'function';
};

is.obj = function (a) {
  return Object.prototype.toString.call(a) === '[object Object]';
};

is.url = function (a) {
  return a instanceof URL;
};

is.set = function (a) {
  return a instanceof Set;
};

is.map = function (a) {
  return a instanceof Map;
};

is.big = function (a) {
  return is.str(a) && a === a.toUpperCase();
};

is.len = function (l, a) {
  return a && (is.arr(a) ? a : Object.keys(a)).length === l;
};

// ************************* 🍡 join-url 🍡 ************************* //
// * This function is fork of join-url/urljoin
// * Code : https://github.com/jfromaniello/url-join/blob/master/lib/url-join.js
// ************************* *************** ************************* //
function joinURL() {
  for (var _len = arguments.length, strArray = new Array(_len), _key = 0; _key < _len; _key++) {
    strArray[_key] = arguments[_key];
  }

  var resultArray = [];
  if (strArray.length === 0) return '';
  if (typeof strArray[0] !== 'string') throw new TypeError('Url must be string.');
  if (strArray[0].match(/^[^/:]+:\/*$/) && strArray.length > 1) strArray[0] = strArray.shift() + strArray[0];
  if (strArray[0].match(/^file:\/\/\//)) strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, '$1:///');else strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, '$1://');
  strArray = strArray.filter(function (str) {
    return str !== "";
  });

  for (var i = 0; i < strArray.length; i++) {
    var _str = strArray[i];
    if (typeof _str === 'number') _str = String(_str);
    if (typeof _str !== 'string') throw new TypeError(_str + " must be a string. Received " + typeof _str);
    if (_str === '') continue;
    if (i > 0) _str = _str.replace(/^[\/]+/, ''); //eslint-disable-line

    if (i < strArray.length - 1) _str = _str.replace(/[\/]+$/, ''); //eslint-disable-line
    else _str = _str.replace(/[\/]+$/, '/'); //eslint-disable-line

    resultArray.push(_str);
  }

  var str = resultArray.join('/');
  str = str.replace(/\/(\?|&|#[^!])/g, '$1');
  var parts = str.split('?');
  str = parts.shift() + (parts.length > 0 ? '?' : '') + parts.join('&');
  return str;
}

function log() {
  var _console;

  (_console = console).log.apply(_console, arguments);
}

log.text = "\n  __                      _\n_/ __\\   ____    ____   /  _\\\n/  _/  /\\/  ___ \\/  ___ \\ \\/_ /\n\\/_   _ / /  ___/ / __  /  _\\ _   __    ____\n/ /  / /\\ \\__  \\ /  ___/ /  /\\ _\\/ __\\/ ____ \\\n\\/__/  \\/_____ /\\_____/\\/_ /\\/ _/ /  / / __  /\n                         /  _/  / /  __ /\n                         \\/___ /\\/__/\n";

log.toString = function () {
  return console.log(log.text);
};

// ************************* 🍭 helpers 🍭 ************************* //
function merge(target, lowercase) {
  if (lowercase === void 0) {
    lowercase = true;
  }

  return function (object) {
    return (is.arr(object) ? object : Object.keys(object)).reduce(function (acc, element) {
      var key = lowercase ? element[0].toLowerCase() + element.substring(1) : element;
      acc[key] = target(key);
      return acc;
    }, target);
  };
}

var topUp = function topUp(text) {
  if (text === void 0) {
    text = "";
  }

  return "" + text.charAt(0).toUpperCase() + "" + text.slice(1).toLowerCase();
};
var clamp = function clamp(x, min, max) {
  if (min === void 0) {
    min = 0;
  }

  if (max === void 0) {
    max = 1;
  }

  return x < min ? min : x > max ? max : x;
};
var range = function range(x, min, max) {
  if (min === void 0) {
    min = 0;
  }

  if (max === void 0) {
    max = 1;
  }

  return min < x && x < max;
};
var swap = function swap(arr, ind, row) {
  var ret = [].concat(arr.slice(0, ind), arr.slice(ind + 1, arr.length));
  return [].concat(ret.slice(0, row), arr.slice(ind, ind + 1), ret.slice(row));
};

var sample = function sample(a, k, init) {
  return [].concat(a.slice(0, k), k - a.length > 0 ? Array(k - a.length).fill(init || a[0]) : []);
};

function initSplit(o, l, dis) {
  if (o === void 0) {
    o = [];
  }

  if (l === void 0) {
    l = 0;
  }

  if (dis === void 0) {
    dis = 256;
  }

  if (o.length < 1) return Array(l).fill(l > 0 ? 1 / l : l);
  return sample(o, l, -1).map(function (v) {
    if (v === void 0) {
      v = 0;
    }

    return v > 0 && (v <= 1 ? v : v / dis) || v < 0 && -1 || 0;
  }).map(function (v, _, s) {
    return v >= 0 ? v : 1 - [].concat(s.filter(function (v) {
      return v > 0;
    }), [0]).reduce(function (a, b) {
      return a + b;
    }) / s.filter(function (v) {
      return v < 0;
    }).length;
  });
}
function moveSplit(r, k, mx, s, m, l, dis) {
  if (r === void 0) {
    r = [];
  }

  if (k === void 0) {
    k = 0;
  }

  if (mx === void 0) {
    mx = 0;
  }

  if (s === void 0) {
    s = 1;
  }

  if (m === void 0) {
    m = 0;
  }

  if (l === void 0) {
    l = 0;
  }

  if (dis === void 0) {
    dis = 256;
  }

  return function (i) {
    if (i === void 0) {
      i = 0;
    }

    return [k, k + s].every(function (e) {
      return range(e, -1, l);
    }) ? (i === k || i === k + s) && range(r[i] + mx * s * (i === k ? 1 : -1) / dis, m, r[k] + r[k + s] - m) ? {
      r: r[i] + mx * s * (i === k ? 1 : -1) / dis
    } : null : (i === k || i === k - s) && range(r[i] - mx * s * (i === k ? 1 : -1) / dis, m, r[k] + r[k - s] - m) ? {
      r: r[i] - mx * s * (i === k ? 1 : -1) / dis
    } : null;
  };
}

function useSplit(props) {
  var _props$children = props.children,
      children = _props$children === void 0 ? null : _props$children,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      _props$min = props.min,
      min = _props$min === void 0 ? 0 : _props$min,
      _props$width = props.width,
      width = _props$width === void 0 ? is.und(window) ? 0 : window.innerWidth : _props$width,
      _props$height = props.height,
      height = _props$height === void 0 ? is.und(window) ? 0 : window.innerHeight : _props$height,
      _props$order = props.order,
      order = _props$order === void 0 ? [] : _props$order,
      _props$vertical = props.vertical,
      vertical = _props$vertical === void 0 ? false : _props$vertical;
  var len = useMemo(function () {
    return (children == null ? void 0 : children.length) || 0;
  }, [children]);
  var dis = useMemo(function () {
    return vertical ? height : width;
  }, [vertical, height, width]);
  var sRef = useRef(0);
  var rRef = useRef(initSplit(order, len, dis));

  var _useSprings = useSprings(len, function (i) {
    return {
      r: rRef.current[i]
    };
  }),
      s = _useSprings[0],
      _ = _useSprings[1];

  var bind = useGesture({
    onDrag: function onDrag(_ref) {
      var first = _ref.first,
          last = _ref.last,
          _ref$args = _ref.args,
          key = _ref$args[0],
          movement = _ref.movement,
          direction = _ref.direction;

      var _map = [movement, direction].map(function (xy) {
        return xy[vertical ? 1 : 0];
      }),
          m = _map[0],
          d = _map[1];

      if (sRef.current === 0 || first) sRef.current = sign(d);
      if (sign(d) === sRef.current) _(moveSplit(rRef.current, key, m, sign(d), min, len, dis));
      if (last) rRef.current = s.map(function (s) {
        return s.r.animation.to || 0;
      });
    }
  }); // *************** RENDER *************** //

  var styles = useCallback(function (i) {
    var _s$i, _s$i$r, _s$i2, _s$i2$r;

    if (i === void 0) {
      i = 0;
    }

    return _extends({}, style, vertical ? {
      width: "100%",
      height: (_s$i = s[i]) == null ? void 0 : (_s$i$r = _s$i.r) == null ? void 0 : _s$i$r.to(function (v) {
        if (v === void 0) {
          v = 0;
        }

        return 100 * v + "%";
      })
    } : {
      height: "100%",
      width: (_s$i2 = s[i]) == null ? void 0 : (_s$i2$r = _s$i2.r) == null ? void 0 : _s$i2$r.to(function (v) {
        if (v === void 0) {
          v = 0;
        }

        return 100 * v + "%";
      })
    }, {
      verticalAlign: "top",
      display: (vertical ? "" : "inline-") + "block"
    });
  }, [vertical, s, style]);
  useEffect(function () {
    rRef.current = initSplit(order, len, dis);

    _(function (i) {
      return {
        r: rRef.current[i]
      };
    });
  }, [order, len, dis, _]);
  return [styles, bind];
}

function sign(num) {
  if (num === void 0) {
    num = 0;
  }

  return num < 0 && -1 || num > 0 && 1 || num === 0 && 0 || 0;
}

var _templateObject$4, _templateObject2$3;
var SplitWrapp = styled(animated.div)(_templateObject$4 || (_templateObject$4 = _taggedTemplateLiteralLoose(["\n    width: 100%;\n    height: 100%;\n    whiteSpace: nowrap;\n"])));
var SplitChild = styled(animated.div)(_templateObject2$3 || (_templateObject2$3 = _taggedTemplateLiteralLoose([""])));
function Split(props) {
  var _useSplit = useSplit(props),
      styles = _useSplit[0],
      bind = _useSplit[1];

  return /*#__PURE__*/React$1.createElement(SplitWrapp, {
    style: props.style
  }, React$1.Children.map(props.children, function (children, key) {
    return /*#__PURE__*/React$1.createElement(SplitChild, _extends({
      style: styles(key)
    }, bind(key), {
      key: key,
      children: children
    }));
  }));
}

function Modal(props) {
  var _props$open = props.open,
      open = _props$open === void 0 ? false : _props$open,
      _props$onClose = props.onClose,
      onClose = _props$onClose === void 0 ? null : _props$onClose,
      _props$dark = props.dark,
      dark = _props$dark === void 0 ? false : _props$dark,
      _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      children = props.children,
      _props$color = props.color,
      color = _props$color === void 0 ? "" : _props$color,
      other = _objectWithoutPropertiesLoose(props, ["open", "onClose", "dark", "size", "children", "color"]);

  var width = useMemo(function () {
    return 500 * size;
  }, [size]);

  var _useSpring = useSpring(function () {
    return {
      x: 0,
      y: -width,
      scale: 0
    };
  }),
      s = _useSpring[0],
      set = _useSpring[1];

  var bind = useGesture({
    onHover: function onHover(_ref) {
      var hovering = _ref.hovering;
      return set({
        scale: hovering ? 0.9 : 1
      });
    },
    onDrag: function onDrag(_ref2) {
      var last = _ref2.last,
          down = _ref2.down,
          _ref2$vxvy = _ref2.vxvy,
          vx = _ref2$vxvy[0],
          vy = _ref2$vxvy[1],
          _ref2$movement = _ref2.movement,
          mx = _ref2$movement[0],
          my = _ref2$movement[1],
          cancel = _ref2.cancel;
      if ((my < -width * .5 || width * .5 < my) && cancel) cancel();
      if (!last) return set({
        x: down ? mx : 0,
        y: down ? my : 0
      });
      return Math.pow(mx, 2) < Math.pow(width, 2) / 4 && Math.pow(vx, 2) + Math.pow(vy, 2) < 10 ? set({
        x: 0,
        y: 0,
        scale: 1
      }) : set({
        x: vx * width,
        y: (vy - 1) * width,
        scale: 0
      }) && onClose && setTimeout(function () {
        return onClose();
      }, Math.pow(vx, 2) + Math.pow(vy, 2));
    }
  });
  var root = useMemo(function () {
    return document.getElementById('root');
  }, []);
  var style = useMemo(function () {
    return _extends({
      left: 0,
      width: "100%",
      display: "flex",
      justifyContent: "center",
      top: 0,
      height: "100%",
      position: "fixed",
      alignItems: "center",
      transition: "1s",
      color: color || dark ? "#212121" : "#000",
      zIndex: 200,
      background: "rgba(" + (dark ? "80,80,80" : "0,0,0") + ",.5)"
    }, other.style);
  }, [dark, color, other.style]);
  useEffect(function () {
    open && set({
      x: 0,
      y: 0,
      scale: 1
    });
  }, [open, set]);
  return open ? /*#__PURE__*/createPortal( /*#__PURE__*/React.createElement("div", {
    style: style,
    onClick: function onClick() {
      return onClose && onClose();
    }
  }, /*#__PURE__*/React.createElement(animated.div, _extends({
    style: _extends({
      position: "relative"
    }, s)
  }, bind(), {
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }), children)), root) : null;
}

function usePulls(_ref) {
  var _ref$onOpen = _ref.onOpen,
      onOpen = _ref$onOpen === void 0 ? function () {
    return void null;
  } : _ref$onOpen,
      _ref$onClose = _ref.onClose,
      onClose = _ref$onClose === void 0 ? function () {
    return void null;
  } : _ref$onClose,
      _ref$wheelRate = _ref.wheelRate,
      wheelRate = _ref$wheelRate === void 0 ? -0.5 : _ref$wheelRate,
      _ref$dragRate = _ref.dragRate,
      dragRate = _ref$dragRate === void 0 ? 1 : _ref$dragRate,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? 0 : _ref$timeout,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 100 : _ref$width,
      _ref$align = _ref.align,
      align = _ref$align === void 0 ? "bottom" : _ref$align,
      _ref$limit = _ref.limit,
      limit = _ref$limit === void 0 ? 0 : _ref$limit,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 1 : _ref$size,
      _ref$rate = _ref.rate,
      rate = _ref$rate === void 0 ? 1 : _ref$rate,
      _ref$open = _ref.open,
      open = _ref$open === void 0 ? false : _ref$open;

  var _useSpring = useSpring(function () {
    return setup(width * size, align);
  }),
      spring = _useSpring[0],
      set = _useSpring[1];

  var timeouted = useRef(false);
  var changed = useCallback(function (opened) {
    if (opened === void 0) {
      opened = 1;
    }

    set(opened ? {
      x: 0,
      y: 0
    } : setup(width * size, align));
    if (!opened && onClose) onClose();
    if (opened && onOpen) onOpen();
    if (timeout <= 0 || opened <= 0 || timeouted.current) return;
    timeouted.current = true;
    setTimeout(function () {
      return void (timeouted.current = false, changed(0));
    }, timeout);
  }, [align, set, size, timeout, width, onOpen, onClose]);
  var dist = width * size;
  var axis = align === "bottom" || align === "top" ? 1 : 0;
  var sign = align === "bottom" || align === "right" ? -1 : 1;
  var bind = useGesture({
    onWheel: function onWheel(_ref2) {
      var _set;

      var last = _ref2.last,
          wheeling = _ref2.wheeling,
          movement = _ref2.movement;
      var move = movement[axis] * wheelRate * rate;
      var next = (wheeling ? move : 0) - dist * sign;
      var isLimited = limit && move > limit;
      if (last || isLimited) changed(move * sign > dist);else set((_set = {}, _set[["x", "y"][axis]] = next, _set[["y", "x"][axis]] = 0, _set));
    },
    onDrag: function onDrag(_ref3) {
      var _set2;

      var last = _ref3.last,
          dragging = _ref3.dragging,
          movement = _ref3.movement;
      var move = movement[axis] * dragRate * rate;
      var next = (dragging ? move : 0) - dist * sign;
      var end = limit && move * sign > limit;
      if (last || end) changed(move * sign > dist);else set((_set2 = {}, _set2[["x", "y"][axis]] = next, _set2[["y", "x"][axis]] = 0, _set2));
    }
  });
  useEffect(function () {
    return void changed(open && align);
  }, [open, align, changed]);
  return [spring, bind];
}

function setup(v, align) {
  if (v === void 0) {
    v = 0;
  }

  if (align === void 0) {
    align = "bottom";
  }

  var x = {
    top: 0,
    bottom: 0,
    left: -v,
    right: v
  }[align] || 0;
  var y = {
    top: -v,
    bottom: v,
    left: 0,
    right: 0
  }[align] || 0;
  return {
    x: x,
    y: y
  };
}

var _templateObject$3, _templateObject2$2;
var Wrap$1 = styled(animated.div)(_templateObject$3 || (_templateObject$3 = _taggedTemplateLiteralLoose(["\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    position: absolute;\n    pointer-events: all;\n    overflow: hidden;\n"])));
var Item = styled(animated.div)(_templateObject2$2 || (_templateObject2$2 = _taggedTemplateLiteralLoose(["\n    position: absolute;\n    ", "\n    ", "\n"])), function (_ref) {
  var align = _ref.align;
  return align + ": 0px;";
}, function (_ref2) {
  var align = _ref2.align,
      width = _ref2.width,
      size = _ref2.size;
  return align === "left" || align === "right" ? "width: " + width * size + "px; height: 100%;" : "width: 100%; height: " + width * size + "px;";
});
var Pulls = /*#__PURE__*/React$1.forwardRef(function (props, ref) {
  var _props$align = props.align,
      align = _props$align === void 0 ? "bottom" : _props$align,
      _props$width = props.width,
      width = _props$width === void 0 ? 100 : _props$width,
      _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style;

  var _usePulls = usePulls(props),
      _usePulls$ = _usePulls[0],
      x = _usePulls$.x,
      y = _usePulls$.y,
      bind = _usePulls[1];

  return /*#__PURE__*/React$1.createElement(Wrap$1, _extends({}, bind(), {
    ref: ref,
    style: style
  }), /*#__PURE__*/React$1.createElement(Item, {
    style: {
      x: x,
      y: y
    },
    size: size,
    align: align,
    width: width
  }, props.children));
});

var styles = {
  pill: {
    position: "absolute",
    padding: "0px",
    zIndex: 1,
    transform: "translate(-50%,-50%)"
  }
};
function Pills(props) {
  var _props$position = props.position,
      position = _props$position === void 0 ? {
    x: 0,
    y: 0,
    r: Math.PI / 4
  } : _props$position,
      _props$depth = props.depth,
      depth = _props$depth === void 0 ? 0 : _props$depth,
      _props$rate = props.rate,
      rate = _props$rate === void 0 ? 1.414 : _props$rate,
      _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size,
      _props$isOpen = props.isOpen,
      isOpen = _props$isOpen === void 0 ? true : _props$isOpen,
      other = _objectWithoutPropertiesLoose(props, ["position", "depth", "rate", "size", "isOpen"]);

  var length = useMemo(function () {
    var _other$children;

    return (other == null ? void 0 : (_other$children = other.children) == null ? void 0 : _other$children.length) || 1;
  }, [other]);
  var childPos = useRef(Array(length).fill(position));
  var fn = useCallback(function () {
    return function (i) {
      if (i === void 0) {
        i = 0;
      }

      var r = position.r / 2 + Math.PI / 2 * ((length - i - 1) * 10 + 1) / ((length - 1) * 10 + 2) - Math.PI / 8;
      var x = isOpen ? 50 * rate * size * Math.cos(r) : 0;
      var y = isOpen ? -50 * rate * size * Math.sin(r) : 0;
      childPos.current[i] = {
        x: x,
        y: -y,
        r: r
      };
      return {
        x: x,
        y: y,
        scale: isOpen ? 1 : 0
      };
    };
  }, [isOpen, length, position.r, rate, size]);

  var _useSprings = useSprings(length, fn()),
      springs = _useSprings[0],
      set = _useSprings[1];

  var _useState = useState(Array(length).fill(false)),
      childHub = _useState[0],
      setChildHub = _useState[1];

  var setHub = useCallback(function (e, key) {
    setChildHub(function (p) {
      var _Object$assign;

      return Object.assign([], p, (_Object$assign = {}, _Object$assign[key] = !p[key], _Object$assign));
    });
    e.stopPropagation();
  }, []);
  var children = useMemo(function () {
    return Children.map(other.children, function (child, key) {
      var _other;

      set(fn());
      return child && child != null && (_other = child.other) != null && _other.children ? /*#__PURE__*/React$1.cloneElement(child, {
        children: /*#__PURE__*/React$1.createElement(Pills, _extends({
          key: key,
          isOpen: isOpen && childHub[key],
          depth: depth + 1,
          position: childPos.current[key],
          rate: rate * (1 + (depth + 1) * 0.2),
          fontSize: 50 * size / (1 + (depth + 1) * 0.2)
        }, child.other || {}))
      }) : child;
    });
  }, [childHub, depth, fn, isOpen, other.children, rate, set, size]);
  return /*#__PURE__*/React$1.createElement("div", {
    style: {
      position: "fixed",
      left: position.x,
      bottom: position.y
    }
  }, springs.map(function (spring, key) {
    return /*#__PURE__*/React$1.createElement(animated.div, {
      key: depth + "-" + key,
      style: _extends({}, spring, styles.pill),
      onClick: function onClick(e) {
        return setHub(e, key);
      }
    }, children[key]);
  }));
}

function useSides(props) {
  var _props$width = props.width,
      width = _props$width === void 0 ? is.und(window) ? 0 : window.innerWidth / 2 : _props$width,
      _props$onOpen = props.onOpen,
      onOpen = _props$onOpen === void 0 ? function () {
    return null;
  } : _props$onOpen;
  var opened = useRef(0);

  var _useSpring = useSpring(function () {
    return {
      x: 0,
      y: 0,
      s: 1
    };
  }),
      spring = _useSpring[0],
      set = _useSpring[1];

  var run = function run(o) {
    if (o === void 0) {
      o = 1;
    }

    return (opened.current = o, onOpen && onOpen());
  };

  var open = function open(v) {
    if (v === void 0) {
      v = 0;
    }

    return (run(1), set({
      x: width,
      y: 0,
      config: v !== 0 ? config.wobbly : config.slow
    }));
  };

  var close = function close(v) {
    if (v === void 0) {
      v = 0;
    }

    return (run(0), set({
      x: 0,
      y: 0,
      config: _extends({}, config.stiff, {
        velocity: v
      })
    }));
  };

  var bind = useGesture({
    onHover: function onHover(_ref) {
      var hovering = _ref.hovering;
      return set({
        s: hovering ? 1.2 : 1
      });
    },
    onDrag: function onDrag(_ref2) {
      var last = _ref2.last,
          down = _ref2.down,
          _ref2$vxvy = _ref2.vxvy,
          vx = _ref2$vxvy[0],
          _ref2$movement = _ref2.movement,
          mx = _ref2$movement[0],
          my = _ref2$movement[1],
          cancel = _ref2.cancel;
      if ((my < -width * .5 || width * .5 < my) && cancel) cancel();
      if (!last) return set({
        x: (opened.current ? width : 0) + (down ? mx : 0),
        y: down ? my : 0
      });
      if (!opened.current) return mx === 0 || mx > width * 0.5 || vx > 0.5 ? open(vx) : close(vx);
      if (opened.current) return mx === 0 || mx < -width * 0.5 || vx < -0.5 ? close(vx) : open(vx);
    }
  });
  return [spring, bind];
}

var _templateObject$2, _templateObject2$1, _templateObject3$1, _templateObject4$1, _templateObject5$1;
var SidesTop = styled.div(_templateObject$2 || (_templateObject$2 = _taggedTemplateLiteralLoose(["\n    top: 0;\n    left: 0;\n"])));
var SidesArea = styled(animated.div)(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteralLoose(["\n    top: 0;\n    left: 0;\n    height: 100%;\n    transition: 0.25s;\n    position: absolute;\n"])));
var SidesWrap = styled(animated.div)(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteralLoose(["\n    top: 2%;\n    left: 0px;\n    height: 96%;\n    padding-top: ", "px;;\n    border-radius: ", ";\n    overflow-x: scroll;\n    background: #212121;\n    position: absolute;\n"])), function (_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? 1 : _ref$size;
  return size * 50;
}, function (_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 1 : _ref2$size;
  return "0px " + 50 * size + "px " + 50 * size + "px 0px";
});
var SidesIcon = styled(animated.div)(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteralLoose(["\n    top: ", "px;\n    left: ", "px;\n    position: absolute;\n"])), function (_ref3) {
  var _ref3$size = _ref3.size,
      size = _ref3$size === void 0 ? 1 : _ref3$size;
  return 25 * size;
}, function (_ref4) {
  var _ref4$size = _ref4.size,
      size = _ref4$size === void 0 ? 1 : _ref4$size;
  return 25 * size;
});
var SidesItem = styled(animated.div)(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteralLoose(["\n    color: #818181;\n    display: block;\n    padding: 10px 10px 10px 50px;\n    transition: 0.75s;\n    font-size: ", "px;\n"])), function (_ref5) {
  var _ref5$size = _ref5.size,
      size = _ref5$size === void 0 ? 1 : _ref5$size;
  return 50 * size;
});
var Sides = function Sides(props) {
  var size = props.size,
      _props$fa = props.fa,
      fa = _props$fa === void 0 ? "align-left" : _props$fa,
      children = props.children;

  var _useSides = useSides(props),
      _useSides$ = _useSides[0],
      x = _useSides$.x,
      y = _useSides$.y,
      s = _useSides$.s,
      bind = _useSides[1];

  var wrap = {
    width: x.to(function (x) {
      return x > 0 ? x : 0;
    })
  },
      area = {
    width: x.to(function (x) {
      return x > 0 ? "100%" : size * 25 + "px";
    }),
    background: s.to(function (s) {
      var rate = is.und(window) ? 0 : x.animation.to / window.innerWidth + s - 1;
      return "linear-gradient(90deg,rgba(0,0,0," + rate + "),rgba(0,0,0,0))";
    })
  };
  return /*#__PURE__*/React$1.createElement(SidesTop, {
    style: props.style
  }, /*#__PURE__*/React$1.createElement(SidesIcon, _extends({}, bind(), {
    size: size,
    style: {
      x: x,
      y: y,
      scale: s
    }
  }), /*#__PURE__*/React$1.createElement(Icon, {
    fa: fa,
    size: size,
    circ: false
  })), /*#__PURE__*/React$1.createElement(SidesArea, _extends({}, bind(), {
    size: size,
    style: area
  })), /*#__PURE__*/React$1.createElement(SidesWrap, _extends({}, bind(), {
    size: size,
    style: wrap
  }), React$1.Children.map(children, function (child, key) {
    return /*#__PURE__*/React$1.createElement(SidesItem, {
      children: child,
      key: key,
      size: size
    });
  })));
};

var _templateObject$1;
function useSheet(_ref) {
  var _ref$height = _ref.height,
      height = _ref$height === void 0 ? 100 : _ref$height,
      _ref$started = _ref.started,
      started = _ref$started === void 0 ? false : _ref$started,
      _ref$onOpen = _ref.onOpen,
      onOpen = _ref$onOpen === void 0 ? null : _ref$onOpen,
      _ref$onClose = _ref.onClose,
      onClose = _ref$onClose === void 0 ? null : _ref$onClose;

  var _useSpring = useSpring(function () {
    return {
      y: height
    };
  }),
      spring = _useSpring[0],
      set = _useSpring[1];

  var open = useCallback(function (c) {
    if (c === void 0) {
      c = false;
    }

    return onOpen && (onOpen(), set({
      y: 0,
      config: c ? config.wobbly : config.stiff
    }));
  }, [onOpen, set]);
  var close = useCallback(function (v) {
    if (v === void 0) {
      v = 0;
    }

    return onClose && (onClose(), set({
      y: height,
      config: _extends({}, config.stiff, {
        velocity: v
      })
    }));
  }, [height, onClose, set]);
  var bind = useDrag(function (_ref2) {
    var last = _ref2.last,
        _ref2$vxvy = _ref2.vxvy,
        vy = _ref2$vxvy[1],
        _ref2$movement = _ref2.movement,
        mx = _ref2$movement[0],
        my = _ref2$movement[1],
        cancel = _ref2.cancel;
    if (my < -height / 3) cancel && cancel();
    if (last) return (my > height * 0.5 || vy > 2.5) && -100 < mx && mx < 100 ? close(vy) : open(vy > 0);
    set({
      y: my,
      immediate: false,
      config: config.stiff
    });
  }, {
    initial: function initial() {
      return [0, spring.y.get()];
    },
    filterTaps: true,
    bounds: {
      top: 0
    },
    rubberband: true
  });
  var f = useRef(function (started) {
    return started ? open() : close();
  });
  useEffect(function () {
    f.current(started);
  }, [started]);
  return [spring, bind];
}
var Wrap = styled(animated.div)(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteralLoose(["\n    bottom: ", ";\n    left: 2vw;\n    width: 96vw;\n    height: calc(100vh + 100px);\n    z-index: 1;\n    position: fixed;\n    background: rgba(0,0,0,0);\n    touch-action:  none;\n    border-radius: 4em 4em 0px;\n"])), function (_ref3) {
  var height = _ref3.height;
  return "calc(-100vh + " + (height - 100) + "px)";
});
function Sheet(props) {
  var _useSheet = useSheet(props),
      y = _useSheet[0].y,
      bind = _useSheet[1];

  var display = y.to(function (py) {
    if (py === void 0) {
      py = 0;
    }

    return py < props.height ? 'block' : 'none';
  });
  return /*#__PURE__*/React.createElement(Wrap, _extends({}, bind(), {
    height: props.height,
    style: {
      y: y,
      display: display
    }
  }), props.children);
}

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6;
function useTrans(_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? 1 : _ref$size,
      _ref$onOpen = _ref.onOpen,
      onOpen = _ref$onOpen === void 0 ? function () {
    return null;
  } : _ref$onOpen;
  var opened = useRef(1);

  var _useSpring = useSpring(function () {
    return {
      x: 0,
      y: 0,
      r: 90,
      s: 1
    };
  }),
      spring = _useSpring[0],
      set = _useSpring[1];

  var getr = function getr(v) {
    if (v === void 0) {
      v = 0;
    }

    var pre = ~~(spring.r.animation.to / 90); //  Math.round( spring.r.animation.to/90 || 0 ) //

    var unit = (opened.current === pre % 2 ? 0 : 1) ? 0 : 1; //to change:1 no diff:0

    return 90 * (pre + unit * (v < 0 ? -1 : 1));
  };

  var run = function run(v) {
    if (v === void 0) {
      v = 0;
    }

    return (opened.current = v, onOpen && onOpen());
  };

  var open = function open(v) {
    if (v === void 0) {
      v = 0;
    }

    return (run(1), set({
      r: getr(v),
      config: v !== 0 ? config.wobbly : config.slow
    }));
  };

  var close = function close(v) {
    if (v === void 0) {
      v = 0;
    }

    return (run(0), set({
      r: getr(v),
      config: _extends({}, config.stiff)
    }));
  };

  var onBind = function onBind(_ref2) {
    var _ref2$mx = _ref2.mx,
        mx = _ref2$mx === void 0 ? 0 : _ref2$mx,
        _ref2$vx = _ref2.vx,
        vx = _ref2$vx === void 0 ? 0 : _ref2$vx,
        _ref2$down = _ref2.down,
        down = _ref2$down === void 0 ? false : _ref2$down,
        _ref2$last = _ref2.last,
        last = _ref2$last === void 0 ? false : _ref2$last;
    if (!last) return set({
      r: spring.r.animation.to + (down ? 2 * -mx / size / 500 : 0)
    });
    if (!opened.current) return mx === 0 || mx < -size * 250 || vx < -0.5 ? open(-vx) : close(-vx);
    if (opened.current) return mx === 0 || mx < -size * 250 || vx < -0.5 || 0.5 < vx ? close(-vx) : open(-vx);
  };

  var bind = useGesture({
    onHover: function onHover(_ref3) {
      var hovering = _ref3.hovering;
      return set({
        s: hovering ? 1.2 : 1
      });
    },
    onPinch: function onPinch(_ref4) {
      var last = _ref4.last,
          down = _ref4.down,
          _ref4$offset = _ref4.offset;
          _ref4$offset[0];
          var a = _ref4$offset[1];
      return onBind({
        down: down,
        last: last,
        vx: 0,
        mx: a
      });
    },
    onDrag: function onDrag(_ref5) {
      var last = _ref5.last,
          down = _ref5.down,
          _ref5$vxvy = _ref5.vxvy,
          vx = _ref5$vxvy[0],
          _ref5$movement = _ref5.movement,
          mx = _ref5$movement[0];
      return onBind({
        down: down,
        last: last,
        vx: vx,
        mx: mx
      });
    }
  });
  return [spring, bind];
}
function Trans(props) {
  var size = props.size,
      children = props.children;

  var _useTrans = useTrans(props),
      _useTrans$ = _useTrans[0],
      r = _useTrans$.r,
      s = _useTrans$.s,
      bind = _useTrans[1];

  var wrap = {
    width: r.to(function (r) {
      if (r === void 0) {
        r = 0;
      }

      return 50 * size * (Math.cos(r / 90 * Math.PI) + 1) + "px";
    })
  },
      area = {
    width: r.to(function (r) {
      return 50 * size * (Math.cos(r / 90 * Math.PI) + 1.5) + "px";
    }),
    background: s.to(function (s) {
      return ["linear-gradient(90deg", "rgba(0,0,0,0)", "rgba(0,0,0," + (s - 1) + "))"].join(',');
    })
  };
  return /*#__PURE__*/React$1.createElement(TransTop, bind(), /*#__PURE__*/React$1.createElement(TransIcon, {
    size: size,
    style: {
      rotateZ: r
    }
  }, /*#__PURE__*/React$1.createElement(Icon, {
    fa: "align-justify",
    circ: false,
    size: size
  })), /*#__PURE__*/React$1.createElement(TransArea, {
    size: size,
    style: area
  }), /*#__PURE__*/React$1.createElement(TransWrap, {
    size: size,
    style: wrap
  }, React$1.Children.map(children, function (child, key) {
    return /*#__PURE__*/React$1.createElement(TransItem, {
      size: size,
      key: key
    }, /*#__PURE__*/React$1.createElement(TransToggle, {
      size: size,
      children: child
    }));
  })));
}
var TransTop = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n    top: 0px;\n    right: 0px;\n    z-index: 100;\n    background: rgba(0,0,0,0.1);\n"])));
var TransArea = styled(animated.div)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n    top: 0px;\n    right: 0px;\n    height: 100%;\n    position: absolute;\n"])));
var TransIcon = styled(animated.div)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["\n    top: ", "px;\n    right: ", "px;\n    transform: translate(-50%,-50%);\n    position: absolute;\n"])), function (_ref6) {
  var size = _ref6.size;
  return 25 * size;
}, function (_ref7) {
  var size = _ref7.size;
  return 25 * size;
});
var TransWrap = styled(animated.div)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["\n    margin: ", ";\n    height: 96%;\n    top: 2%;\n    right: 0px;\n    overflow-x: hidden;\n    position: absolute;\n"])), function (_ref8) {
  var size = _ref8.size;
  return "calc(" + 50 * size * 2 + "px - 2%) 0px 0px 0px";
});
var TransItem = styled(animated.div)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["\n    margin: ", ";\n    border-radius: ", ";\n    color: #818181;\n    display: inline-block;\n    background-color: #212121;\n"])), function (_ref9) {
  var size = _ref9.size;
  return 50 * size / 4 + "px 0px";
}, function (_ref10) {
  var size = _ref10.size;
  return 50 * size + "px 0px  0px " + 50 * size + "px";
});
var TransToggle = styled.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["\n    font-size: ", "px;\n    height: ", "px;\n    margin: ", ";\n    align-items: center;\n    display: flex;\n    z-index: 1;\n"])), function (_ref11) {
  var size = _ref11.size;
  return 50 * size;
}, function (_ref12) {
  var size = _ref12.size;
  return 50 * size;
}, function (_ref13) {
  var size = _ref13.size;
  return "auto " + 50 * size / 2 + "px";
});

export { Card, Foot, Grow, Head, Icon, Modal, Pills, Pulls, Sheet, Sides, Slide, Split, Trans, Trees, clamp, initSplit, is, joinURL, log, merge, moveSplit, range, swap, topUp, treesPaths, useCard, useGrow, useIcon, useSheet, useSlide, useSplit, useTrans, useTrees };
